﻿using System;
using System.Data;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace UltraGridTabbing
{
    public partial class Form1 : Form
    {
        private UltraGrid lastFocusedGrid = null;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraGrid1.InitializeLayout += new Infragistics.Win.UltraWinGrid.InitializeLayoutEventHandler(grid_InitializeLayout);
            ultraGrid2.InitializeLayout += new Infragistics.Win.UltraWinGrid.InitializeLayoutEventHandler(grid_InitializeLayout);
            ultraGrid3.InitializeLayout += new Infragistics.Win.UltraWinGrid.InitializeLayoutEventHandler(grid_InitializeLayout);

            ultraGrid1.DataSource = GetDataTable();
            ultraGrid2.DataSource = GetDataTable();
            ultraGrid3.DataSource = GetDataTable();

            ultraGrid1.GotFocus += new EventHandler(grid_GotFocus);
            ultraGrid2.GotFocus += new EventHandler(grid_GotFocus);
            ultraGrid3.GotFocus += new EventHandler(grid_GotFocus);
        }

        private void grid_GotFocus(object sender, EventArgs e)
        {
            if (lastFocusedGrid != null && lastFocusedGrid != (sender as UltraGrid))
            {
                (sender as UltraGrid).Rows[0].Cells[0].Activate();
                (sender as UltraGrid).PerformAction(UltraGridAction.EnterEditMode);
            }

            lastFocusedGrid = (sender as UltraGrid);
        }

        private void grid_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.TabNavigation = Infragistics.Win.UltraWinGrid.TabNavigation.NextControlOnLastCell;
        }

        private DataTable GetDataTable(int rows = 1)
        {
            DataTable table = new DataTable("Table1");

            table.Columns.Add("Integer column", typeof(int));
            table.Columns.Add("DateTime column", typeof(DateTime));
            table.Columns.Add("String column", typeof(string));

            for (int i = 0; i < rows; i++)
            {
                DataRow row = table.NewRow();
                row["Integer column"] = i % 2 == 0 ? 5 : 9;
                row["String column"] = "text";
                row["DateTime column"] = DateTime.Today.AddDays(i);
                table.Rows.Add(row);
            }

            return table;
        }
    }
}
